CONTENTS OF THIS FILE
---------------------

 * Introduction
 * Requirements
 * Installation
 * Configuration
 * Extending
 * Maintainers


INTRODUCTION
------------

The `Server Beacon` module provides the ability to transmit reports about a
server's status to a designated reporting station (provided by the
[Report Station](https://www.drupal.org/project/report_station) module). Report
stations collect that information and can make it available for monitoring the
health of an environment and inform maintainers of the availability of updates.


REQUIREMENTS
------------

This module requires the following modules:

 * [Key](https://www.drupal.org/project/key)


INSTALLATION
------------

Install as you would normally install a contributed Drupal module. Visit
https://www.drupal.org/node/1897420 for further information.


CONFIGURATION
-------------

Build and manage server reports at `/admin/config/services/server-beacon` or
navigate to the `Server Beacon Reports` link on the admin web services page.

From here you add and edit the various reports. Ensure that the transmitter
protocols match with the receiver configurations of the target report station.


EXTENDING
---------

Server beacons module provides two different types of plugins.

**Server beacon plugins**

Server beacon plugins generate the status report data that populates reports.
The beacon plugins should produce an array that can be serialized into JSON and
transmitted to a [Report Station](https://www.drupal.org/project/report_station)
receiver.

These plugins implement `\Drupal\server_beacon\Plugin\ServerInterface` and are
placed in the `/plugin/ServerBeacon/Beacon` folder.

 * @see _\Drupal\server_beacon\Attribute\ServerBeacon_
 * @see _\Drupal\server_beacon\Plugin\ServerBeaconInteface_


**Transmitter plugins**

Transmitter plugins are responsible for encoding and sending the reports to a
[Report Station](https://www.drupal.org/project/report_station). They need to
generate a data format and verification protocol for the transmitting the report
data. The receiving report station needs to have a compatible receiving data
protocol. Server beacons module come with a two transmitter plugins.

 * Public key w/ signature: uses private/public keys for encryption and signing.
 * Secret key encryption: uses secret key encrypting and decrypting.

These plugins implement `\Drupal\server_beacon\Plugin\ServerInterface` and are
placed in the `/plugin/ServerBeacon/Transmitter` folder.

 * @see _\Drupal\server_beacon\Attribute\ServerBeaconTransmitter_
 * @see _\Drupal\server_beacon\Plugin\BeaconTransmitterInteface_


MAINTAINERS
-----------

Current maintainers:
 * Liem Khuu (lemming) - https://www.drupal.org/u/lemming
