<?php

namespace Drupal\server_beacon\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;

/**
 * Server beacon handler attributes for plugin discovery.
 *
 * @see \Drupal\server_beacon\Plugin\ServerPluginManager
 * @see \Drupal\server_beacon\Plugin\ServerPluginManagerInterface
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class ServerBeacon extends Plugin {

  /**
   * Creates a new instance of the ServerBeacon plugin attribute.
   *
   * @param string $id
   *   The server beacon handler unique plugin ID.
   * @param \Stringable|string $label
   *   Server beacon human friendly label.
   * @param \Stringable|string|null $description
   *   Server beacon handler description.
   * @param class-string|null $deriver
   *   The plugin deriver for server beacon.
   */
  public function __construct(
    public readonly string $id,
    public \Stringable|string $label,
    public \Stringable|string|null $description = NULL,
    public readonly ?string $deriver = NULL,
  ) {}

}
