<?php

namespace Drupal\server_beacon\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;

/**
 * Server beacon transmitter attribute for plugin discovery.
 *
 * @see \Drupal\server_beacon\Plugin\BeaconTransmitterPluginManager
 * @see \Drupal\server_beacon\Plugin\BeaconTransmitterPluginManagerInterface
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class ServerBeaconTransmitter extends Plugin {

  /**
   * Creates a new instance of the ServerBeaconTransmitter plugin attribute.
   *
   * @param string $id
   *   The server beacon transmitter unique plugin ID.
   * @param \Stringable|string $label
   *   Beacon transmitter human friendly label.
   * @param \Stringable|string|null $description
   *   Beacon transmitter description.
   * @param class-string|null $deriver
   *   The plugin deriver for beacon transmitters.
   */
  public function __construct(
    public readonly string $id,
    public \Stringable|string $label,
    public \Stringable|string|null $description = NULL,
    public readonly ?string $deriver = NULL,
  ) {}

}
