<?php

namespace Drupal\server_beacon\Entity\Controller;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;

/**
 * Entity list builder for server beacon report configurations.
 */
class BeaconReportListBuilder extends EntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader(): array {
    return [
      $this->t('Name'),
      $this->t('Report to'),
      $this->t('Types'),
    ] + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity): array {
    /** @var \Drupal\server_beacon\Entity\ServerBeaconReportInterface $entity */
    return [
      $entity->getName(),
      $entity->reportHost(),
      implode(', ', $entity->getBeaconTypes(TRUE)),
    ] + parent::buildRow($entity);
  }

}
