<?php

namespace Drupal\server_beacon\Plugin;

use Drupal\Component\Plugin\ConfigurableInterface;
use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\Core\Plugin\PluginFormInterface;
use Drupal\server_beacon\Entity\ServerBeaconReportInterface;
use GuzzleHttp\ClientInterface;

/**
 * Base interface for server beacon transmitter protocol plugin.
 */
interface BeaconTransmitterInterface extends PluginInspectionInterface, ConfigurableInterface, PluginFormInterface {

  /**
   * Transmit the report data to the designated server station.
   *
   * @param \Drupal\server_beacon\Entity\ServerBeaconReportInterface $report
   *   The beacon report being sent.
   * @param \GuzzleHttp\ClientInterface $client
   *   The client to use to transmit the report with.
   * @param mixed[] $data
   *   The generated report data to transmit.
   *
   * @return bool
   *   TRUE if the transmission succeed, and FALSE if there was an error.
   */
  public function __invoke(ServerBeaconReportInterface $report, ClientInterface $client, array $data): bool;

}
