<?php

namespace Drupal\server_beacon\Plugin;

use Drupal\Component\Plugin\PluginManagerInterface;

/**
 * The interface for the server beacon transmitter plugin manager.
 */
interface BeaconTransmitterManagerInterface extends PluginManagerInterface {

  /**
   * Get a list of available server beacon transmitters.
   *
   * Gets a list of transmitters with the plugin ID as the key and the
   * transmitter label as the array value. This output is compatible with
   * "#option" properties of form API elements.
   *
   * @return array<string,\Stringable|string>
   *   A list of available transmitter plugins with the plugin ID as the key
   *   and the beacon labels as the value.
   */
  public function getTransmitterOptions(): array;

}
