<?php

namespace Drupal\server_beacon\Plugin;

use Drupal\Component\Plugin\PluginInspectionInterface;

/**
 * Base interface for server beacon plugin services.
 */
interface ServerBeaconInterface extends PluginInspectionInterface {

  /**
   * Fetch and format the status information in preparation for transmitting.
   *
   * Generate the data that will get transmitted and reported to a service
   * stations. The data format should be in the same format that is expected
   * for rendering summaries and status displays.
   *
   * @return array
   *   The server beacon data to include in transmitted reports to a service
   *   station.
   */
  public function fetchStatus(): array;

}
