<?php

namespace Drupal\server_beacon\Plugin;

use Drupal\Component\Plugin\PluginManagerInterface;

/**
 * The interface for the server beacon plugin manager.
 */
interface ServerBeaconManagerInterface extends PluginManagerInterface {

  /**
   * Get a list of available server beacons.
   *
   * Gets a list of beacons with the plugin ID as the key and the beacon label
   * as the array value. This output is compatible with "#option" properties of
   * form API elements.
   *
   * @return array<string,\Stringable|string>
   *   A list of available beacon plugins with the plugin ID as the key and the
   *   beacon labels as the value.
   */
  public function getBeaconOptions(): array;

}
